﻿# **Python演禽**

## **1. 導讀**︰
演禽是中國占卜術之一。古人以象禽星宿，配合天支地支、五行、奇門遁甲推測吉凶、起命盤，也用於行軍打仗。估計此占卜術盛行於明清時代，有關該占卜術的完整介紹及使用方法可見於明朝池本理著《禽遁大全》四卷以及《星禽易見》四卷。除此，還有明代汪三益《參籌秘書》，清代汪紱《戊笈談兵》和《禽遁七元成局書》。星禽易見、禽遁大全可分別被視為演禽術入門及進階的必讀書籍。禽遁大全後兩卷混合了奇門遁甲的命盤原理，加上八門八宮，更為複雜。本套件主要參考《禽遁大全》、《星禽易見》二書內容而編制的。

## **2. 基本知識**︰
禽星總共二十八宿，依次包括︰角木蛟、亢金龍、氐土貉、房日兔、心月狐、尾火虎、箕水豹、斗木獬、牛金牛、女土蝠、虛日鼠、危月燕、室火豬、壁水狳、奎木狼、婁金狗、胃土雉、昴日雞、畢月烏、觜火猴、參水猿、井木犴、鬼金羊、柳土獐、星日馬、張月鹿、翼火蛇、軫水蚓。

演禽主要以日期時間做占卜，即以年、月、日、時找出駐守的禽星，因應年月日時而產生出 "氣將"、"倒將"、"翻禽"、"活曜" 等各個變量名詞。參照了古本說明及網上基本教學，建立了可以尋找年月日時禽及上述幾個變量名詞的資料庫。

凡占婚姻，以番禽為男家，到將為女家，日禽為媒人。如我尅他，或他尅我，婚則不成，成亦終不偕和。如他禽生我，則婚易成，亦主偕老。若我禽生他，婚亦難成。若彼我之禽比和，亦成。如日禽尅我，或我禽尅日，則主媒人不得力。若日禽得地生我者，則媒人得力，親事易成。若彼我之禽與日時之禽共臨三合之位，婚亦易成。

凡占求財，以番禽為求財之人，到將為出財之人，日禽為財並牙保之人，三禽和禽不相　制者，其財易求，而謀事亦遂。若日禽與他禽尅我，為財尅我，難求。如我禽　他，半吉。若日禽尅他禽，必為中間人阻當，難成。

## **3. 安裝套件**
本套件需要安裝pandas和sxtwl。

```python
	pip install yincome
```

## **4. 起星方式**
```python
	from yincome import yincome
	
	#簡單查找年月日時干支
	yincome.ymd()  #查看今年何月何日何時星期幾
	yincome.gangzhi(year, month, day, hour) #找年月日時天支地支
	yincome.gangzhi_current() #查看目前年月日時干支
	
	#昔日年禽、月禽、日禽、時禽、翻禽、倒將、活曜、日禽VS時禽鎖泊
	yincome.date(year, month, day, hour)
	yincome.year_chin(year)
	yincome.month_chin(year, month, day)
	yincome.day_n_hour_chin(year, month, day, hour)
	
	#查看七元甲子
	yincome.checkyuen(year, month, day, hour)
	#番禽
	yincome.fan_chin(year, month, day, hour)
	
	#倒將
	yincome.dou_jiang(year, month, day, hour)
	
	#活曜
	yincome.huo_yao(year, month, day, hour)

	#今日年禽、月禽、日禽、時禽、翻禽、倒將、活曜、日禽VS時禽鎖泊
	yincome.rightnow()

	#求財
	yincome.money()
	yincome.money2()

	#男問卜者求愛情
	yincome.manlove()

	#女問卜者求愛情
	yincome.womanlove()
	
	#占主客戰果 (以翻禽倒將為主客)
	yincome.vsnow()
	yincome.vs(year, month, day, hour)
	
	#占主客戰果 (以日禽時禽為客主)
	yincome.vsnow2()
	yincome.vs2(year, month, day, hour)
	
	#禽星鑽泊
	yincome.sopo_location(animal, hour)
	
	
	#禽星對戰
	yincome.animal_vs_results(animal1, animal2)
	
```
