﻿# -*- coding: utf-8 -*-
"""
Created on Sat Dec  7 15:40:37 2019

@author: ken tang
@email: kinyeah@gmail.com
"""

import pandas as pd
import sxtwl, os, datetime, calendar

#current date
now = datetime.datetime.now()
now_year = str(now.year)
now_month = str(now.month)
now_day =  str(now.day)
now_hour = str(now.hour)
now_whichday = str(now.strftime("%a"))

#old date
lunar = sxtwl.Lunar()
root = os.path.abspath(os.path.dirname(__file__))
data = os.path.join(root, 'data')


#importing data
Gan = ["甲", "乙", "丙", "丁", "戊", "己", "庚", "辛", "壬", "癸"]
Zhi = ["子", "丑", "寅", "卯", "辰", "巳", "午", "未", "申", "酉", "戌", "亥"]
chin_28_stars_code = {'1': '角木蛟', '2': '亢金龍', '3': '氐土貉', '4': '房日兔', '5': '心月狐', '6': '尾火虎', '7': '箕水豹', '8': '斗木獬', '9': '牛金牛', '10': '女土蝠', '11': '虛日鼠', '12': '危月燕', '13': '室火豬', '14': '壁水㺄', '15': '奎木狼', '16': '婁金狗', '17': '胃土雉', '18': '昴日雞', '19': '畢月烏', '20': '觜火猴', '21': '參水猿', '22': '井木犴', '23': '鬼金羊', '24': '柳土獐', '25': '星日馬', '26': '張月鹿', '27': '翼火蛇', '28': '軫水蚓'}
chin_28_stars = ['角木蛟', '亢金龍', '氐土貉', '房日兔', '心月狐', '尾火虎', '箕水豹', '斗木獬', '牛金牛', '女土蝠', '虛日鼠', '危月燕', '室火豬', '壁水㺄', '奎木狼', '婁金狗', '胃土雉', '昴日雞', '畢月烏', '觜火猴', '參水猿', '井木犴', '鬼金羊', '柳土獐', '星日馬', '張月鹿', '翼火蛇', '軫水蚓']

#sky_land = {'1': '甲子', '2': '乙丑', '3': '丙寅', '4': '丁卯', '5': '戊辰', '6': '己巳', '7': '庚午', '8': '辛未', '9': '壬申', '10': '癸酉', '11': '甲戌', '12': '乙亥', '13': '丙子', '14': '丁丑', '15': '戊寅', '16': '己卯', '17': '庚辰', '18': '辛巳', '19': '壬午', '20': '癸未', '21': '甲申', '22': '乙酉', '23': '丙戌', '24': '丁亥', '25': '戊子', '26': '己丑', '27': '庚寅', '28': '辛卯', '29': '壬辰', '30': '癸巳', '31': '甲午', '32': '乙未', '33': '丙申', '34': '丁酉', '35': '戊戌', '36': '己亥', '37': '庚子', '38': '辛丑', '39': '壬寅', '40': '癸卯', '41': '甲辰', '42': '乙巳', '43': '丙午', '44': '丁未', '45': '戊申', '46': '己酉', '47': '庚戌', '48': '辛亥', '49': '壬子', '50': '癸丑', '51': '甲寅', '52': '乙卯', '53': '丙辰', '54': '丁巳', '55': '戊午', '56': '己未', '57': '庚申', '58': '辛酉', '59': '壬戌', '60': '癸亥'}
#sky_land_reversed = {'甲子': '1', '乙丑': '2', '丙寅': '3', '丁卯': '4', '戊辰': '5', '己巳': '6', '庚午': '7', '辛未': '8', '壬申': '9', '癸酉': '10', '甲戌': '11', '乙亥': '12', '丙子': '13', '丁丑': '14', '戊寅': '15', '己卯': '16', '庚辰': '17', '辛巳': '18', '壬午': '19', '癸未': '20', '甲申': '21', '乙酉': '22', '丙戌': '23', '丁亥': '24', '戊子': '25', '己丑': '26', '庚寅': '27', '辛卯': '28', '壬辰': '29', '癸巳': '30', '甲午': '31', '乙未': '32', '丙申': '33', '丁酉': '34', '戊戌': '35', '己亥': '36', '庚子': '37', '辛丑': '38', '壬寅': '39', '癸卯': '40', '甲辰': '41', '乙巳': '42', '丙午': '43', '丁未': '44', '戊申': '45', '己酉': '46', '庚戌': '47', '辛亥': '48', '壬子': '49', '癸丑': '50', '甲寅': '51', '乙卯': '52', '丙辰': '53', '丁巳': '54', '戊午': '55', '己未': '56', '庚申': '57', '辛酉': '58', '壬戌': '59', '癸亥': '60'}
#eightgua_sky_land = {('甲子', '乙丑', '丙寅', '戊子', '己丑', '庚寅', '壬子', '癸丑', '甲寅'): '休坎一', ('丁卯', '戊辰', '己巳', '辛卯', '壬辰', '癸巳', '乙卯', '丙辰', '丁巳'): '休坤二', ('庚午', '辛未', '壬申', '甲午', '乙未', '丙申', '戊午', '己未', '庚申'): '休震三', ('癸酉', '甲戌', '乙亥', '丁酉', '戊戌', '己亥', '辛酉', '壬戌', '癸亥'): '休巽四', ('丙子', '丁丑', '戊寅', '庚子', '辛丑', '壬寅'): '休乾五', ('己卯', '庚辰', '辛巳', '癸卯', '甲辰', '乙巳'): '休兌六', ('壬午', '癸未', '甲申', '丙午', '丁未', '戊申'): '休艮七', ('乙酉', '丙戌', '丁亥', '己酉', '庚戌', '辛亥'): '休離八'}

hour_chin_place_list = {'寅': '山', '卯': '林', '辰': '草', '巳': '湯', '午': '火', '未': '園', '申': '刀', '酉': '砧', '戌': '野', '亥': '湖', '子': '江', '丑': '田'}
day_chin_place_list = {'寅': '山', '卯': '水', '辰': '田', '巳': '園', '午': '井', '未': '刀', '申': '天', '酉': '草', '戌': '岸', '亥': '風', '子': '湯火', '丑': '月'}
day_chin_place_good_or_bad_list = {('狐山', '雉山', '虎山', '豹山', '虎林', '豹林', '狼山', '狼林', '犴山', '犴林', '猿山', '猿林', '猴山', '猴林', '獐山', '獐林', '蛇山', '蛇林', '鹿山', '鹿林', '蚓江', '蛟江', '龍江', '㺄江', '蚓湖', '蛟湖', '龍湖', '㺄湖', '兔山', '犴山', '㺄山', '獐山', '雞田', '雉田', '兔田', '犴刀','獐刀', '牛田', '牛野', '牛路', '馬田', '馬野', '馬路', '狗田', '狗野', '狗路', '獬田', '獬野', '獬路', '豬田', '羊野', '羊路', '狐野', '兔野', '狼崗'): '吉', ('蛟湯', '龍湯', '貉湯', '兔湯', '狐湯', '虎湯', '豹湯', '獬湯', '牛湯', '蝠湯', '鼠湯', '燕湯', '豬湯', '㺄湯', '狼湯', '狗湯', '雉湯', '雞湯', '烏湯', '猴湯', '猿湯', '犴湯', '羊湯', '獐湯', '馬湯', '鹿湯', '蛇湯', '蚓湯', '蛟火', '龍火', '貉火', '兔火', '狐火', '虎火', '豹火', '獬火', '牛火', '蝠火', '鼠火', '燕火', '豬火', '㺄火', '狼火', '狗火', '雉火', '雞火', '烏火', '猴火', '猿火', '犴火', '羊火', '獐火', '馬火', '鹿火', '蛇火', '蚓火', '蛟刀', '龍刀', '貉刀', '兔刀', '狐刀', '虎刀', '豹刀', '獬刀', '牛刀', '蝠刀', '鼠刀', '燕刀', '豬刀', '㺄刀', '狼刀', '狗刀', '雉刀', '雞刀', '烏刀', '猴刀', '猿刀', '犴刀', '羊刀', '獐刀', '馬刀', '鹿刀', '蛇刀', '蚓刀', '蛟砧', '龍砧', '貉砧', '兔砧', '狐砧', '虎砧', '豹砧', '獬砧', '牛砧', '蝠砧', '鼠砧', '燕砧', '豬砧', '㺄砧', '狼砧', '狗砧', '雉砧', '雞砧', '烏砧', '猴砧', '猿砧', '犴砧', '羊砧', '獐砧', '馬砧', '鹿砧', '蛇砧', '蚓砧', '蚓田', '豹湖', '羊湖', '貉湖', '貉江', '狗野', '猴崗', '猿崗', '雞崗', '羊崗', '烏崗', '犴林', '㺄林', '獐路', '馬山', '鹿山', '豬山', '羊山', '鼠田', '獐田', '鹿田', '貉刀', '兔刀', '狐刀', '虎刀', '豹刀', '獬刀', '牛刀', '豬刀', '鼠刀', '狼刀', '狗刀', '猴刀', '猿刀', '羊刀', '馬刀', '鹿刀', '蛇刀', '蛟山', '龍山', '虎江', '虎湖', '狼江', '狼湖', '豹江', '豬江', '羊江', '雞山', '牛山'): '凶', ('蛟刀', '龍刀', '蝠刀', '燕刀', '雉刀', '雞刀', '㺄刀', '蚓刀'): '平'}
hour_chin_place_good_or_bad_list = {('犴山', '貉山', '兔山', '馬山', '獐山', '虎山', '豹山', '雉山', '雞山', '狐山', '鹿山', '猿山', '猴山', '蛇山', '狼山', '蛟水', '龍水', '㺄水', '蛇水', '雞田', '雉田', '兔田', '馬田', '羊田', '牛田', '狗田', '猴園', '猿園', '豬園', '獬園', '羊園', '狗園', '牛園', '雞園', '狼園', '兔園', '蛟井', '龍井', '蚓井', '㺄井', '犴刀', '獐刀', '蛟天', '龍天', '貉天', '兔天', '狐天', '虎天', '豹天', '獬天', '牛天', '蝠天', '鼠天', '燕天', '豬天', '㺄天', '狼天', '狗天', '雉天', '雞天', '烏天', '猴天', '猿天', '犴天', '羊天', '獐天', '馬天', '鹿天', '蛇天', '蚓天', '牛草', '羊草', '獐草', '鹿草', '馬草', '狼草', '豬草', '兔草', '蛇岸', '蚓岸', '豬岸', '羊岸', '虎岸', '烏岸', '犴岸', '狐岸', '馬岸', '蛟風', '龍風', '貉風', '兔風', '狐風', '虎風', '豹風', '獬風', '牛風', '蝠風', '鼠風', '燕風', '豬風', '㺄風', '狼風', '狗風', '雉風', '雞風', '烏風', '猴風', '猿風', '犴風', '羊風', '獐風', '馬風', '鹿風', '蛇風', '蚓風', '狗湯火', '獬月', '狼月', '犴月', '牛月', '羊月', '貉月', '蝠月', '雉月', '獐月', '兔月', '雞月', '鼠月', '馬月', '狐月', '燕月', '烏月', '鹿月', '虎月', '豬月', '猴月', '豹月', '㺄月', '猿月', '狗月'): '吉', ('蚓山', '㺄山', '龍山', '鹿水', '虎水', '鼠水', '兔水', '獬水', '狼水', '犴水', '牛水', '狗水', '羊水', '貉水', '獐水', '馬水', '狐水', '鹿水', '豬水', '猴水', '猿水', '豹水', '蚓田', '獬田', '狼田', '犴田', '貉田', '蝠田', '狐田', '燕田', '烏田', '猴田', '虎田', '豬田', '蛇田', '豹田', '㺄田', '猿田', '龍園', '蛟園', '蝠園', '鼠園', '燕園', '貉園', '狐園', '豹園', '㺄園', '雉園', '烏園', '犴園', '羊園', '獐園', '馬園', '鹿園', '蚓園', '兔刀', '虎刀', '豹刀', '獬刀', '牛刀', '豬刀', '鼠刀', '猴刀', '猿刀', '羊刀', '馬刀', '鹿刀', '蛇刀', '蛟草', '龍草', '蛟岸', '㺄岸', '貉岸', '豹岸', '獬岸', '蝠岸', '牛岸', '蝙岸', '鼠岸', '燕岸', '㺄岸', '狼岸', '狗岸', '雉岸', '雞岸', '猿岸', '獐岸', '鹿岸', '蛟湯火', '獬湯火', '狼湯火', '犴湯火', '龍湯火', '牛湯火', '羊湯火', '貉湯火', '獐湯火', '兔湯火', '鼠湯火', '馬湯火', '狐湯火', '鹿湯火', '虎湯火', '豬湯火', '猴湯火', '蛇湯火', '豹湯火', '㺄湯火', '猿湯火', '蚓湯火'): '凶', ('蛟山', '獬山', '牛山', '蝠山', '鼠山', '燕山', '烏山', '雉井', '雞井', '烏井', '蝙井', '燕井', '蛟刀', '龍刀', '蚓刀', '㺄刀', '蝠刀', '燕刀', '雉刀', '雞刀', '烏刀', '貉刀', '獬草', '犴草', '狗草', '貉草', '蝠草', '獐草', '雞草', '鼠草', '狐草', '燕草', '烏草', '虎草', '猴草', '蛇草', '豹草', '㺄草', '猿草', '蚓草', '蝠湯火', '雉湯火', '燕湯火', '烏湯火', '雞湯火', '龍月', '蛇月', '蛟月', '蚓月'): '平', ('豬山', '狗山', '羊山', '燕水', '蝠水', '雉水', '烏水', '雞水', '鼠田', '獐田', '鹿田', '龍田', '蛟田', '蛇園', '獬井', '狼井', '犴井', '牛井', '狗井', '羊井', '貉井', '獐井', '兔井', '鼠井', '馬井', '狐井', '鹿井', '虎井', '豬井', '猴井', '蛇井', '豹井', '猿井', '狼刀', '狗刀', '狐刀', '龍岸'): '忌'}
animal_change_list = {'蛟山': '蛟不變', '龍山': '龍化蛇', '犴山': '犴化獅', '㺄山': '㺄化蛤', '貉山': '貉化狐', '雞水': '雞化鳳', '蛟田': '蛟化龜', '龍田': '龍化蛇', '雞田': '雞化鳳', '㺄田': '㺄化龍', '豬田': '豬化龍', '蛟井': '蛟化㺄', '龍井': '龍化㺄', '蛟天': '蛟化龍', '貉天':'貉化麒麟', '虎天': '虎化麒麟', '狼天': '狼化麒麟', '兔天': '兔化麒麟', '狐天': '狐化麒麟', '蛇天': '蛇化龍', '牛天': '牛化象', '狗天': '狗化鰲', '雞天': '雞化鳳', '鼠天': '鼠化貓', '烏天': '烏化鳳', '雉天': '雉化鳳', '燕天': '燕化鳳', '蝙天': '蝙化鳳', '豹天': '豹化飛虎', '猴岸': '猴化狒', '猿岸': '猿化狒', '蚓月': '蚓化龜', '狗湯火': '狗化獅', '龍湯火': '龍化魚', '兔月': '兔化玉兔', '狗月': '狗化龍', '雉月': '雉化鸞', '雞月': '雞化鳳', '豬月': '豬化象', '雉江': '雉化蛟', '雉湖': '雉化蛟', '狗湯': '狗化天鰲，能擒狼豹', '狗田': '狗化天鰲，能擒狼豹', '燕砧': '燕化鵬，反食蛟龍', '雞江': '雞化蛟', '雉火': '雉化鷹', '烏山': '烏化鵬，食牛'}
day_bagua_list = {('甲子', '乙丑', '丙寅', '戊子', '己丑', '庚寅', '壬子', '癸丑', '甲寅'): '吉︰開乾(西北), 休坎(北), 生艮(東北)    凶︰傷震(東), 杜巽(東南), 景離(南), 死坤(西南), 驚兌(西)', ('丁卯', '戊辰', '己巳', '辛卯', '壬辰', '癸巳', '乙卯', '丙辰', '丁巳'): '      吉︰開離(南), 休坤(西南), 生兌(西)    凶︰傷乾(西北), 杜坎(北), 景艮(東北), 死震(東), 驚巽(東南)', ('庚午', '辛未', '壬申', '甲午', '乙未', '丙申', '戊午', '己未', '庚申'): '吉︰開艮(東北), 休震(東), 生巽(東南)    凶︰傷離(南), 杜坤(西南), 景兌(西), 死乾(西北), 驚坎(北)', ('癸酉', '甲戌', '乙亥', '丁酉', '戊戌', '己亥', '辛酉', '壬戌', '癸亥'): '吉︰休巽(東南), 生離(南)     凶︰傷坤(西南), 杜兌(西), 景乾(西北), 死坎(北), 驚艮(東北), 開震(東)', ('丙子', '丁丑', '戊寅', '庚子', '辛丑', '壬寅'): '吉︰開兌(西), 休乾(西北), 生坎(北)      凶︰傷艮(東北), 杜震(東), 景巽(東南), 死離(南), 驚坤(西南)', ('己卯', '庚辰', '辛巳', '癸卯', '甲辰', '乙巳'): '吉︰休兌(西), 生乾(西北)    凶︰傷坎(北), 杜艮(東北), 景震(東), 死巽(東南), 驚離(南), 開坤(西南)', ('壬午', '癸未', '甲申', '丙午', '丁未', '戊申'): '吉︰休艮(東北), 生震(東)    凶︰傷巽(東南), 杜離(南), 景坤(西南), 死兌(西), 驚乾(西北), 開坎(北)', ('乙酉', '丙戌', '丁亥', '己酉', '庚戌', '辛亥'): '吉︰休離(南), 生坤(西南)     凶︰傷兌(西), 杜乾(西北), 景坎(北), 死艮(東北), 驚震(東), 開巽(東南)'}
hour_bagua_list = {('火', '日'): '吉位︰尊艮(東北), 帝巽(東南), 福離(南), 生坤(西南)    凶位︰傷震(東), 死兌(西), 敗乾(西北), 休坎(北)', ('月', '水', '土'): '吉位︰尊坤(西南), 帝乾(西北), 福坎(北), 生艮(東北)    凶位︰傷兌(西), 死震(東), 敗巽(東南), 休離(南)', '木': '吉位︰尊乾(西北), 帝艮(東北), 福震(東), 生巽(東南)    凶位︰傷坎(北), 死離(南), 敗坤(西南), 休兌(西)', '金': '吉位︰尊巽(東南), 帝坤(西南), 福兌(西), 生乾(西北)     凶位︰傷離(南), 死坎(北), 敗艮(東北), 休震(東)'}
sopo_head_list = {"日":"午", "月":"未", "火":"寅", "水":"申", "土":"申", "木":"亥", "金": "巳"}
chinstar_levels = {"角木蛟":"強水禽", "亢金龍":"強水禽", "氐土貉":"平山禽", "房日兔":"弱山禽", "心月狐":"平山禽", "尾火虎":"強山禽","箕水豹":"強山禽", "斗木獬":"強山禽", "牛金牛":"平家禽", "女土蝠":"平飛禽", "虛日鼠":"弱山禽", "危月燕":"平飛禽", "室火豬":"弱家禽", "壁水㺄":"平水禽", "奎木狼":"強山禽", "婁金狗":"小強家禽", "胃土雉":"弱飛禽", "昴日雞":"弱家禽", "畢月烏":"強飛禽", "觜火猴":"平山禽", "參水猿":"平山禽", "井木犴":"大強山禽", "鬼金羊":"弱家禽", "柳土獐":"弱山禽","星日馬":"小強家禽","張月鹿":"平山禽","翼火蛇":"平山禽", "軫水蚓":"最弱山禽"}
lunar_month_code_for_month_table = {"正月":"0", "二月":"1", "三月":"2", "四月":"3","五月":"4","六月":"5","七月":"6","八月":"7","九月":"8","十月":"9","十一月":"10", "十二月":"11"}


define_date_to_chinese_date = {'Mon': '1', 'Tue': '2', 'Wed': '3', 'Thu': '4', 'Fri': '5', 'Sat': '6', 'Sun': '0'}
#houyaohead_code = {"日":"畢月烏", "月":"尾火虎", "金":"牛金牛", "木":"虛日鼠", "水":"氐土貉", "火":"奎木狼", "土":"翼火蛇"}
month_chin_table = pd.read_csv(os.path.join(root, 'data', 'month_chin.csv'), index_col=None) #月禽快速查找表
day_chin_table = pd.read_csv(os.path.join(root, 'data', 'day_chin.csv'), index_col=None) #日禽快速查找表
seven_yuen_table = pd.read_csv(os.path.join(root, 'data', 'seven_yuen.csv'), index_col=None)
seven_yuen_table_transposed = pd.read_csv(os.path.join(root, 'data', 'seven_yuen_transposed.csv'), index_col=None) #七元甲子時禽速查表橫向顯示
animal_change_table = pd.read_csv(os.path.join(root, 'data', 'animal_change_table.csv'), index_col=0)
chinstar_inhabit_place_hour = pd.read_csv(os.path.join(root, 'data','chin_star_inhabit_place_hour.csv'), index_col=0)


#七元時禽表
yuen_one = pd.read_csv(os.path.join(root, 'data', 'yuen_one.csv'), index_col=None) 
yuen_two = pd.read_csv(os.path.join(root, 'data', 'yuen_two.csv'), index_col=None) 
yuen_three = pd.read_csv(os.path.join(root, 'data', 'yuen_three.csv'), index_col=None) 
yuen_four = pd.read_csv(os.path.join(root, 'data', 'yuen_four.csv'), index_col=None) 
yuen_five = pd.read_csv(os.path.join(root, 'data', 'yuen_five.csv'), index_col=None) 
yuen_six = pd.read_csv(os.path.join(root, 'data', 'yuen_six.csv'), index_col=None) 
yuen_seven = pd.read_csv(os.path.join(root, 'data', 'yuen_seven.csv'), index_col=None) 
seven_yuen_for_hour_chin = {0:yuen_one, 1:yuen_two, 2:yuen_three, 3:yuen_four, 4:yuen_five, 5:yuen_six, 6:yuen_seven}
fanchin_table = pd.read_csv(os.path.join(root, 'data', 'fanchin_table.csv'), index_col =0)
doujiang_table = pd.read_csv(os.path.join(root, 'data', 'doujiang_table.csv'), index_col =0)
huoyao_table = pd.read_csv(os.path.join(root, 'data', 'huoyao_table.csv'), index_col =0)
seven_yuen_define = {0:"一元甲子", 1:"二元甲子", 2:"三元甲子", 3:"四元甲子", 4:"五元甲子", 5:"六元甲子", 6:"七元甲子"}
hour_row_code = {"子":0, "丑":1, "寅":2, "卯":3, "辰":4, "巳":5, "午":6, "未":7, "申":8, "酉":9, "戌":10, "亥":11}
sevenyao_column_code = {"日":1, "月":2, "火":3, "水":4, "木":5, "金":6, "土":7}
#import yincome vs
chinstar_vs = pd.read_csv(os.path.join(root, 'data', 'chin_star_vs_ha.csv'), index_col=0) 
#chin_28_stars_vs_row = {'角木蛟':0, '亢金龍':1, '氐土貉':2, '房日兔':3, '心月狐':4, '尾火虎':5, '箕水豹':6,  '斗木獬':7, '牛金牛':8, '女土蝠':9, '虛日鼠':10,'危月燕':11, '室火豬':12, '壁水㺄':13, '奎木狼':14, '婁金狗':15, '胃土雉':16, '昴日雞':17, '畢月烏':18, '觜火猴':19, '參水猿':20, '井木犴':21, '鬼金羊':22, '柳土獐':23, '星日馬':24, '張月鹿':25, '翼火蛇':26, '軫水蚓':27}
#chin_28_stars_vs_column = {'角木蛟':1, '亢金龍':2, '氐土貉':3, '房日兔':4, '心月狐':5, '尾火虎':6, '箕水豹':7,  '斗木獬':8, '牛金牛':9, '女土蝠':10, '虛日鼠':11,'危月燕':12, '室火豬':13, '壁水㺄':14, '奎木狼':15, '婁金狗':16, '胃土雉':17, '昴日雞':18, '畢月烏':19,'觜火猴':20, '參水猿':21, '井木犴':22, '鬼金羊':23, '柳土獐':24, '星日馬':25, '張月鹿':26, '翼火蛇':27, '軫水蚓':28}

def lunar_date(cyear, cmonth, cday):
    lunar = sxtwl.Lunar()  #实例化日历库
    ymc = [u"十一", u"十二", u"正", u"二", u"三", u"四", u"五", u"六", u"七", u"八", u"九", u"十" ]
    rmc = [u"初一", u"初二", u"初三", u"初四", u"初五", u"初六", u"初七", u"初八", u"初九", u"初十",
     u"十一", u"十二", u"十三", u"十四", u"十五", u"十六", u"十七", u"十八", u"十九",
      u"二十", u"廿一", u"廿二", u"廿三", u"廿四", u"廿五", u"廿六", u"廿七", u"廿八", u"廿九", u"三十", u"卅一"]
    day = lunar.getDayBySolar(cyear, cmonth, cday)
    if day.Lleap:
        ld =  "潤"+ ymc[day.Lmc]+"月"+rmc[day.Ldi]+"日"
    else:
        ld = ymc[day.Lmc]+"月"+ rmc[day.Ldi]+"日"
    return ld


def jiazi():
    tiangan = '甲乙丙丁戊己庚辛壬癸'
    dizhi = '子丑寅卯辰巳午未申酉戌亥'
    jiazi = [tiangan[x % len(tiangan)] + dizhi[x % len(dizhi)] for x in range(60)]
    return jiazi

def new_zhi_list(zhi):
    Zhi = ["子", "丑", "寅", "卯", "辰", "巳", "午", "未", "申", "酉", "戌", "亥"]
    zhihead_code = Zhi.index(zhi)
    res1 = []
    for i in range(len(Zhi)):
        res1.append( Zhi[zhihead_code % len(Zhi)])
        zhihead_code = zhihead_code + 1
    return res1

def sopo_location(animal, hour):
    sopo_head_list = {"日":"午", "月":"未", "火":"寅", "水":"申", "土":"申", "木":"亥", "金": "巳"}
    sopo = ["山", "水", "田","園","井", "刀", "天", "草", "岸", "風", "湯", "月"]
    chinstar_nature = {"角木蛟":"水禽", "亢金龍":"水禽", "氐土貉":"走禽", "房日兔":"走禽", "心月狐":"走禽", "尾火虎":"走禽","箕水豹":"走禽", "斗木獬":"走禽", "牛金牛":"走禽", "女土蝠":"飛禽", "虛日鼠":"走禽", "危月燕":"飛禽", "室火豬":"走禽", "壁水㺄":"水禽", "奎木狼":"走禽", "婁金狗":"走禽", "胃土雉":"飛禽", "昴日雞":"走禽", "畢月烏":"飛禽", "觜火猴":"走禽", "參水猿":"走禽", "井木犴":"走禽", "鬼金羊":"走禽", "柳土獐":"走禽","星日馬":"走禽","張月鹿":"走禽","翼火蛇":"走禽", "軫水蚓":"走禽"}
    chinstar_trap = {"飛禽辰": "陷天羅", "走禽戌": "陷地網"}
    sopo_head = sopo_head_list.get(animal[1])
    sopo_zhi_list = new_zhi_list(sopo_head)
    trap = chinstar_trap.get(sopo_head+chinstar_nature.get(animal), "沒陷天羅地網")
    return [animal, chinstar_nature.get(animal) ,sopo_head, dict(zip(sopo_zhi_list, sopo)),dict(zip(sopo_zhi_list, sopo)).get(hour),trap]
    #鎖泊頭地支[2], 鎖泊位[4]

def animal_sopo(animal, inhabitplace):
    return chinstar_inhabit_place_hour[inhabitplace][animal]
    
    
def multi_key_dict_get(d, k):
    for keys, v in d.items():
        if k in keys:
            return v
    return None

def ymd():
    return int(now_year), int(now_month), int(now_day), int(now_hour)

def gangzhi(year, month, day, hour):
    cdate = lunar.getDayBySolar(year, month, day)
    yy_mm_dd = Gan[cdate.Lyear2.tg]+Zhi[cdate.Lyear2.dz],  Gan[cdate.Lmonth2.tg]+Zhi[cdate.Lmonth2.dz],  Gan[cdate.Lday2.tg]+Zhi[cdate.Lday2.dz]
    timegz = lunar.getShiGz(cdate.Lday2.tg, hour)
    new_hh = Gan[timegz.tg]+Zhi[timegz.dz]
    return yy_mm_dd[0], yy_mm_dd[1],  yy_mm_dd[2],  new_hh

def gangzhi_y(year):
    year = lunar.getYearCal(year)
    return Gan[year.yearGan] + Zhi[year.yearZhi]
    
	
def gangzhi_current():
    return  gangzhi(int(now_year), int(now_month), int(now_day), int(now_hour))

def check_lunar_month(year, month, day):
    lunar_date = lunar.getDayByLunar(year, month, day)
    ymc = [u"十一月", u"十二月", u"一月", u"二月", u"三月", u"四月", u"五月", u"六月", u"七月", u"八月", u"九月", u"十月"]
    return str(ymc[lunar_date.Lmc])

def weekday(year, month, day):
    dayNumber = calendar.weekday(year, month, day) 
    days =["Mon", "Tue", "Wed", "Thu", 
                         "Fri", "Sat", "Sun"] 
    return days[dayNumber]

def animal_vs_results(animal1, animal2):
    return [chinstar_vs[animal1][animal2], animal1+chinstar_vs[animal1][animal2]+animal2]
    #先讀Column，再讀row


def checkyuen(year, month, day, hour):
    whichday = weekday(year, month, day)
    get_year_chin_number = (int(year)+15) % 28 #求年禽之公式為西元年加15除28之餘數
    if get_year_chin_number is int(0):
        get_year_chin_number = int(28)
    find_day_code = define_date_to_chinese_date.get(whichday)
    dgz = gangzhi(year, month, day, hour)[2]
    day_chin = day_chin_table[dgz[1]][int(find_day_code)]
    check_seven_yuen = seven_yuen_table_transposed[str(dgz)] == day_chin
    yuen = [i for i, x in enumerate(check_seven_yuen) if x][0] #在boolean選單內檢查日禽在七元甲子時禽速查表哪一行內
    #read_yuen.iloc(int(hchin_row),int(hchin_column))
    yuen_name = seven_yuen_define.get(yuen)
    return yuen_name[0:2]+dgz, yuen


def year_chin(year, month, day, hour):#求年禽
    date_gangzhi = gangzhi(year, month, day, hour)
    year_gangzhi = date_gangzhi[0]
    year_gangzhi2 = gangzhi_y(year)
    if year_gangzhi == year_gangzhi2:
        get_year_chin_number = (int(year)+15) % 28 #求年禽之公式為西元年加15除28之餘數
        if get_year_chin_number == int(0):
            get_year_chin_number = int(28)
        year_chin = chin_28_stars_code.get(str(get_year_chin_number)) #年禽
    elif year_gangzhi != year_gangzhi2:
         get_year_chin_number = (int(year-1)+15) % 28 #求年禽之公式為西元年加15除28之餘數
         if get_year_chin_number == int(0):
            get_year_chin_number = int(28)
         year_chin = chin_28_stars_code.get(str(get_year_chin_number)) #年禽
    return year_chin

def year_chin2(year):#求年禽,不用月日時, 但有誤差
    get_year_chin_number = (int(year)+15) % 28 #求年禽之公式為西元年加15除28之餘數
    if get_year_chin_number == int(0):
        get_year_chin_number = int(28)
    year_chin = chin_28_stars_code.get(str(get_year_chin_number)) #年禽
    return year_chin


def month_chin(year, month, day, hour):#求月禽
    yearchin = year_chin(year, month, day, hour)
    cmonth = lunar_date(year, month, day)[0:lunar_date(year, month, day).index("月")+1]
    monthchin_n = month_chin_table[yearchin[1]][int(lunar_month_code_for_month_table.get(cmonth))]
    return monthchin_n


def day_n_hour_chin(year, month, day, hour):#求日時禽
    dgz = gangzhi(year, month, day, hour)[2]
    hgz = gangzhi(year, month, day, hour)[3]
    whichday = weekday(year, month, day)
    find_day_code = define_date_to_chinese_date.get(whichday)
    day_chin1 = day_chin_table[dgz[1]][int(find_day_code)]
    check_seven_yuen = seven_yuen_table_transposed[str(dgz)] == day_chin1
    yuen = [i for i, x in enumerate(check_seven_yuen) if x][0] #在boolean選單內檢查日禽在七元甲子時禽速查表哪一行內  
    qijiang_list = {tuple(jiazi()[0:15]): seven_yuen_table_transposed.iloc[yuen, 1], 
    (tuple(jiazi()[16:30])): seven_yuen_table_transposed.iloc[yuen, 16],
    (tuple(jiazi()[31:45])): seven_yuen_table_transposed.iloc[yuen, 31],
    (tuple(jiazi()[46:60])): seven_yuen_table_transposed.iloc[yuen, 46]} 
    qijiang = multi_key_dict_get(qijiang_list, dgz)
    read_yuen = seven_yuen_for_hour_chin.get(yuen)
    hchin_column = sevenyao_column_code.get(str(day_chin1[1]))
    hchin_row = hour_row_code.get(str(hgz[1]))
    hourchin = read_yuen.iloc[hchin_row,hchin_column]
    return day_chin1, hourchin, qijiang

def qi_jiang(year, month, day, hour): #氣將
    return day_n_hour_chin(year, month, day, hour)[2]

def dou_jiang(year, month, day, hour):#求倒將
    seven_yuen_name = checkyuen(year, month, day, hour)[0]
    hgz = gangzhi(year, month, day, hour)[3][1]
    doujiang = chin_28_stars_code.get(str(doujiang_table[hgz][seven_yuen_name]))
    return doujiang

def fan_chin(year, month, day, hour):#求倒將
    seven_yuen_name = checkyuen(year, month, day, hour)[0]
    hgz = gangzhi(year, month, day, hour)[3][1]
    fanchin = chin_28_stars_code.get(str(fanchin_table[hgz][seven_yuen_name]))
    return fanchin

def huo_yao(year, month, day, hour):#求活曜
    seven_yuen_name = checkyuen(year, month, day, hour)[0]
    hgz = gangzhi(year, month, day, hour)[3][1]
    huoyao = chin_28_stars_code.get(str(huoyao_table[hgz][seven_yuen_name]))
    return huoyao

def date2(year, month, day, hour):
    ygz = gangzhi(year, month, day, hour)[0]
    mgz = gangzhi(year, month, day, hour)[1]
    hgz = gangzhi(year, month, day, hour)[3]
    dgz = gangzhi(year, month, day, hour)[2]
    ychin = year_chin(year, month, day, hour)
    mchin = month_chin(year, month, day, hour)
    dchin = day_n_hour_chin(year, month, day, hour)[0]
    hchin = day_n_hour_chin(year, month, day, hour)[1]
    fchin = fan_chin(year, month, day, hour)
    djiang = dou_jiang(year, month, day, hour)
    hyao = huo_yao(year, month, day, hour)
    qjiang = qi_jiang(year, month, day, hour)
    hour_chin_place2 = inhabit_place(year, month, day, hour)[3]
    day_bagua = multi_key_dict_get(day_bagua_list , str(dgz)) 
    hour_bagua = multi_key_dict_get(hour_bagua_list , str(hchin[1]))
    outcome_dvsf = chinstar_vs[djiang[0:3]][fchin[0:3]]
    outcome_fvsd = chinstar_vs[fchin[0:3]][djiang[0:3]]
    outcome_dvsh = chinstar_vs[hchin[0:3]][dchin[0:3]]
    outcome_hvsd = chinstar_vs[dchin[0:3]][hchin[0:3]]
    yincome_results = [ 
                        str(year)+"/"+str(month)+"/"+str(day)+","+str(hour)+"時("+checkyuen(year, month, day, hour)[0]+"，"+ygz+"年，"+mgz+"月，"+dgz+"日，"+hgz+"時"+")", 
                        "年禽:【"+ygz+"】"+ychin+" ("+chinstar_levels.get(ychin[0:3])+")",
                        "月禽:【"+mgz+"】"+mchin+" ("+chinstar_levels.get(mchin[0:3])+")", 
                        "日禽:【"+dgz+"】"+dchin+" ("+chinstar_levels.get(dchin[0:3])+")"+"("+hour_chin_place2+")"+" ("+sopo_location(dchin[0:3], hgz[1])[4]+") (彼副將)，"+animal_sopo(dchin[0:3], sopo_location(dchin[0:3], hgz[1])[4]),
                        "時禽:【"+hgz+"】"+hchin+" ("+chinstar_levels.get(hchin[0:3])+")"+"("+hour_chin_place2+")"+" ("+sopo_location(hchin[0:3], hgz[1])[4]+") (我副將)，"+animal_sopo(hchin[0:3], sopo_location(hchin[0:3], hgz[1])[4]),       
                        "翻禽:【"+hgz+"】"+fchin+" ("+chinstar_levels.get(fchin[0:3])+")"+"("+hour_chin_place2+")"+" ("+sopo_location(fchin[0:3], hgz[1])[4]+") (彼正將)，"+animal_sopo(fchin[0:3], sopo_location(fchin[0:3], hgz[1])[4]), 
                        "倒將:【"+hgz+"】"+djiang+" ("+chinstar_levels.get(djiang[0:3])+")"+"("+hour_chin_place2+")"+" ("+sopo_location(djiang[0:3], hgz[1])[4]+") (我正將)，"+animal_sopo(djiang[0:3], sopo_location(djiang[0:3], hgz[1])[4]),
                        "活曜:【"+hgz+"】"+hyao+" ("+chinstar_levels.get(hyao[0:3])+")"+"("+hour_chin_place2+")"+" ("+sopo_location(hyao[0:3], hgz[1])[4]+") (我本身)，"+animal_sopo(hyao[0:3], sopo_location(hyao[0:3], hgz[1])[4]),
                        "氣將:【"+hgz+"】"+qjiang+" ("+chinstar_levels.get(qjiang[0:3])+")"+"("+hour_chin_place2+")",
                        "",
                        "分析:",
                        "主將︰倒將為主，翻禽為客。主"+outcome_dvsf+"客"+outcome_fvsd,
                        "副將︰時禽為主，日禽為客。主"+outcome_hvsd+"客"+outcome_dvsh,
                        '日干支吉凶方︰'+day_bagua,
                        '時干支吉凶方︰'+hour_bagua,
                         ]
    return '\n'.join(yincome_results)

def date(year, month, day, hour):
    return print(date2(year, month, day, hour))
	
def rightnow():
    return date(int(now_year), int(now_month), int(now_day), int(now_hour))

def rightnow2():
    return date2(int(now_year), int(now_month), int(now_day), int(now_hour))


def inhabit_place(year, month, day, hour):
    dgz = gangzhi(year, month, day, hour)[2]
    hgz = gangzhi(year, month, day, hour)[3]
    day_chin_place = day_chin_place_list.get(str(dgz[1]))
    hour_chin_place2 = day_chin_place_list.get(str(hgz[1]))
    hour_chin_place = hour_chin_place_list.get(str(hgz[1]))
    return ["日禽鎖泊", day_chin_place, "時禽鎖泊", hour_chin_place, "日辰鎖汨(時)", hour_chin_place2]
    
def manlove():
    current = rightnow2()
    fanchin_male = current[current.index("翻禽")+3: current.index("翻禽")+6]
    doujiang_female = current[current.index("倒將")+3: current.index("倒將")+6]
    daychin_agent = current[current.index("日禽")+7: current.index("日禽")+10]
    marriage_criteria1 = {("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，亦成", ("木火", "木日", "火土", "日土", "土金", "金水", "金月", "水木", "月木"):"我禽生他禽，婚難成", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"他禽生我禽，婚易成，亦主偕老", ("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木","土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"): "我禽尅他禽，或他禽尅我禽，婚則不成，成亦終不偕和。"}
    marriage_criteria2 = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木","土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"): "日禽尅我禽，或我禽尅日禽，媒人不得力。", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"日禽得地生我禽，媒人得力",("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，亦成" }
    result1 = multi_key_dict_get(marriage_criteria1, fanchin_male[1]+doujiang_female[1])
    result2 = multi_key_dict_get(marriage_criteria2, fanchin_male[1]+daychin_agent[1])
    return "翻禽【"+fanchin_male+"】為男家", "倒將【"+doujiang_female+"】為女家", "日禽【"+daychin_agent+"】為媒人" , result1, result2

def womanlove():
    current = rightnow2()
    fanchin_male = current[current.index("翻禽")+7: current.index("翻禽")+10]
    doujiang_female = current[current.index("倒將")+7: current.index("倒將")+10]
    daychin_agent = current[current.index("日禽")+7: current.index("日禽")+10]
    marriage_criteria1 = {("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，亦成", ("木火", "木日", "火土", "日土", "土金", "金水", "金月", "水木", "月木"):"我禽生他禽，婚難成", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"他禽生我禽，婚易成，亦主偕老", ("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木","土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"): "我禽尅他禽，或他禽尅我禽，婚則不成，成亦終不偕和。"}
    marriage_criteria2 = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木","土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"): "日禽尅我禽，或我禽尅日禽，媒人不得力。", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"日禽得地生我禽，媒人得力", ("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，亦成"}
    result1 = multi_key_dict_get(marriage_criteria1, doujiang_female[1]+fanchin_male[1])
    try:    
        result2 = multi_key_dict_get(marriage_criteria2, doujiang_female[1]+daychin_agent[1])
    except (IndexError):
        result2 = ""
    return "倒將【"+doujiang_female+"】為女家", "翻禽【"+fanchin_male+"】為男家", "日禽【"+daychin_agent+"】為媒人" , result1, result2

def money():
    current = rightnow2()
    me = current[current.index("翻禽")+7: current.index("翻禽")+10] #fanchin
    the_one_with_money = current[current.index("倒將")+7: current.index("倒將")+10] #doujiang
    agent = current[current.index("日禽")+7: current.index("日禽")+10]  #daychin
    three_vs_criteria = {("木木木", "木木火", "火火木", "火木火", "木火木", "火火火", "日木日", "日日木", "木日木", "木木日", "日木木", "火木日", "木火日", "日火木", "日木火", "火日木", "木火日", "木日日","木日火", "火土土", "火火土", "土火土", "土火火", "土土土", "土日土", "土日日", "土日火", "土火日", "土土日", "日日土", "日土日", "火日土", "日火土", "日土土", "土土土", "日火火", "日日火", "火火日", "火日火", "日火日", "水水水", "水月水", "水水月", "月月水", "月水月", "月水水", "月月月", "水木木", "水木水", "水水木", "木木水", "木水水", "木月水", "木水月", "月木木", "月木月", "木月月", "月月木", "水月木", "月水木", "土金金", "金土土", "金土金", "土金土", "金金土", "金金金", "土土金", "金金水", "金水金", "金水水", "水金金", "水金水", "水水金", "月水金", "水月金", "金月水", "金水月", "月金水", "水金月", "月月月", "日日日" ):"三禽和禽不相尅制者，其財易求，而謀事亦遂"}
    me_vs_money_criteria = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木"): "我禽尅他禽，半吉", ("土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"):"他禽日禽尅我，即財尅我，難求。", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"他禽生我禽，財易成", ("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，財亦成"}
    money_vs_agent_criteria = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木"): "日禽尅他禽，必為中間人阻當，難成"}                
    try:
        result1 = multi_key_dict_get(three_vs_criteria, me[1]+the_one_with_money[1]+agent[1])
        result2 = multi_key_dict_get(me_vs_money_criteria, me[1]+the_one_with_money[1])
        result3 =  multi_key_dict_get(money_vs_agent_criteria, the_one_with_money[1]+agent[1])
    except (IndexError):
        result1 = ""
        result2 = ""
        result3 = ""
    return "翻禽為【"+me+"】，即求財之人", "倒將為【"+the_one_with_money+"】，即出財之人", "日禽為【"+agent+"】，即牙保之人", result1, result2, result3

def money2():
    current = rightnow2()
    heshe = current[current.index("翻禽")+7: current.index("翻禽")+10] 
    me = current[current.index("時禽")+7: current.index("時禽")+10] 
    money_object = current[current.index("日禽")+7: current.index("日禽")+10]  #daychin
    three_vs_criteria = {("木木木", "木木火", "火火木", "火木火", "木火木", "火火火", "日木日", "日日木", "木日木", "木木日", "日木木", "火木日", "木火日", "日火木", "日木火", "火日木", "木火日", "木日火", "木日日", "火土土", "火火土", "土火土", "土火火", "土土土", "土日土", "土日日", "土日火", "土火日", "土土日", "日日土", "日土日", "火日土", "日火土", "日土土", "土土土", "日火火", "日日火", "火火日", "火日火", "日火日", "水水水", "水月水", "水水月", "月月水", "月水月", "月水水", "月月月", "水木木", "水木水", "水水木", "木木水", "木水水", "木月水", "木水月", "月木木", "月木月", "木月月", "月月木", "水月木", "月水木", "土金金", "金土土", "金土金", "土金土", "金金土", "金金金", "土土金", "金金水", "金水金", "金水水", "水金金", "水金水", "水水金", "月水金", "水月金", "金月水", "金水月", "月金水", "水金月", "月月月", "日日日" ):"三禽和禽不相尅制者，其財易求，而謀事亦遂"}
    me_vs_money_criteria = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木"): "我禽尅他禽，半吉", ("土木", "水土", "月土", "火水", "日月", "金火", "金日", "木金"):"他禽日禽尅我，即財尅我，難求。", ("火木", "日木", "土火", "土日", "金土", "水金", "月金", "木水", "木月"):"他禽生我禽，財易成", ("木木","火火", "土土", "水水", "月月", "日日", "金金", "水月", "月水", "日火", "火日"):"彼我之禽比和，財亦成"}
    money_vs_agent_criteria = {("木土", "土水", "土月", "水火", "月日", "火金", "日金", "金木"): "日禽尅他禽，必為中間人阻當，難成"}                
    try:
        result1 = multi_key_dict_get(three_vs_criteria, me[1]+heshe[1]+money_object[1])
        result2 = multi_key_dict_get(me_vs_money_criteria, me[1]+heshe[1])
        result3 = multi_key_dict_get(me_vs_money_criteria, me[1]+money_object[1])
        result4 =  multi_key_dict_get(money_vs_agent_criteria, money_object[1]+heshe[1])
    except (IndexError):
        result1 = ""
        result2 = ""
        result3 = ""
        result4 = ""
    return "地禽(時禽)【"+me+"】為我，即求財之人", "天禽(翻禽)【"+heshe+"】，即彼或出財之人", "日禽【"+money_object+"】為財", result1, result2, result3, result4

